unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ExtCtrls,math, ComCtrls, Buttons;

type
  TSpielfeld = packed record
    hoehe:single;
    textur:byte;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    VScrollbar: TScrollBar;
    HScrollbar: TScrollBar;
    Spielwelt: TPaintBox;
    UpDown1: TUpDown;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Panel1: TPanel;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    TrackBar2: TTrackBar;
    Label3: TLabel;
    Panel2: TPanel;
    Label4: TLabel;
    ComboBox1: TComboBox;
    Label5: TLabel;
    ComboBox2: TComboBox;
    Button2: TButton;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SpeedButton3: TSpeedButton;
    Panel3: TPanel;
    ComboBox3: TComboBox;
    Label6: TLabel;
    Button4: TButton;
    StatusBar1: TStatusBar;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    procedure Mountain(pos:TPoint;size:integer;hoehe:double);
    procedure Texture(pos:TPoint);
    procedure Button1Click(Sender: TObject);
    procedure SpielweltPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UpDown1ChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure FormResize(Sender: TObject);
    procedure VScrollbarChange(Sender: TObject);
    procedure HScrollbarChange(Sender: TObject);
    procedure SpielweltMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpielweltMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpielweltMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
  private
    Welt:array of array of TSpielfeld;
    WeltPos:TPoint;
    zoom:integer;
    maustaste:integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
  TEX_GRAS        = 0;
  TEX_FELS        = 1;
  TEX_ERDE        = 2;
  TEX_SCHNEE      = 3;



  MB_LEFT=1;
  MB_RIGHT=2;

  LEVEL_SIZE = 512;


implementation

{$R *.dfm}

function getTexColor(tex:byte):TRGBQUAD;
begin
  case tex of
    TEX_GRAS:begin
               result.rgbBlue:=0;
               result.rgbGreen:=255;
               result.rgbRed:=0;
             end;
    TEX_FELS:begin
               result.rgbBlue:=128;
               result.rgbGreen:=128;
               result.rgbRed:=128;
             end;
    TEX_ERDE:begin
               result.rgbBlue:=0;
               result.rgbGreen:=130;
               result.rgbRed:=200;
             end;
    TEX_SCHNEE:begin
               result.rgbBlue:=255;
               result.rgbGreen:=255;
               result.rgbRed:=255;
             end;

  end;
end;

function getTexString(tex:byte):string;
begin
  case tex of
    TEX_GRAS        : result:='Gras';
    TEX_FELS        : result:='Fels';
    TEX_ERDE        : result:='Erde';
    TEX_SCHNEE      : result:='Schnee';
  end;
end;

function getFirstTexture(tex:byte):byte;
begin
  result := tex shr 6;
end;

function getSecondTexture(tex:byte):byte;
begin
  result := (tex shr 4) and 3;
end;

function getTexMulti(tex:byte):byte;
begin
  result := tex and 7;
end;

function composeTexture(first:byte; second:byte; multi:byte):byte;
begin
  first := first and 3;
  second := second and 3;
  multi := multi and 15;
  result := ((first * 4 + second) * 16 + multi);
end;

procedure TForm1.Mountain(pos:TPoint;size:integer;hoehe:double);
var x,y,xmod,ymod:integer;
    dist,berg:double;
begin
  for x:=(pos.x-size) to (pos.x + size) do begin
    for y:=(pos.y-size) to (pos.y + size) do begin
//      if (x>=0)and(x<1000)and(y>=0)and(y<1000) then begin
{        dist:=min(sqrt(sqr(x-pos.x)+sqr(y-pos.y)),size/2);
        dist:=dist/size * PI * 2;
        welt[x,y].hoehe:=welt[x,y].hoehe + (cos(dist)+1)*(hoehe/10);}

        dist:=sqrt(sqr(x-pos.x)+sqr(y-pos.y))*10/size;
        berg:=exp(-dist);
        xmod:= (x + LEVEL_SIZE) mod  LEVEL_SIZE;
        ymod:= (y + LEVEL_SIZE) mod  LEVEL_SIZE;
        welt[xmod,ymod].hoehe:=welt[xmod,ymod].hoehe + berg * hoehe/3;

//      end;
    end;
  end;
end;

procedure TForm1.Texture(pos:TPoint);
var x,y,size:integer;
    dist:double;
begin
  size:=strtoint(ComboBox2.items[ComboBox2.itemindex]);
  for x:=(pos.x-size) to (pos.x + size) do begin
    for y:=(pos.y-size) to (pos.y + size) do begin
//      if (x>=0)and(x<1000)and(y>=0)and(y<1000) then begin
        dist:=sqrt(sqr(x-pos.x)+sqr(y-pos.y));
        if dist<size then begin
          welt[(x + LEVEL_SIZE) mod  LEVEL_SIZE,(y + LEVEL_SIZE) mod  LEVEL_SIZE].textur:=(ComboBox1.ItemIndex and 3)shl 6;
        end;
//      end;
    end;
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
var x,y:integer;
begin
  SetLength(Welt,LEVEL_SIZE);
  for x:=0 to LEVEL_SIZE-1 do begin
    SetLength(Welt[x],LEVEL_SIZE);
    for y:=0 to LEVEL_SIZE-1 do begin
      Welt[x][y].hoehe:=0;
      Welt[x][y].textur:=TEX_GRAS;
    end;
  end;
  zoom:=2;
  SpielweltPaint(Sender);
end;

procedure TForm1.SpielweltPaint(Sender: TObject);
var backbuffer:TBitmap;
    x,y:integer;
    Zeile:PByteArray;
    col1,col2:TRGBQUAD;
    tex1,tex2:byte;
    mult:single;
    red0,green0,blue0,red1,green1,blue1:byte;
    hoehe:byte;
begin
  if not assigned(Welt) then exit;
  backbuffer:=TBitmap.create;
  backbuffer.Width:=Spielwelt.Width div zoom + 1;
  backbuffer.Height:=Spielwelt.Height div zoom + 1;
  backbuffer.PixelFormat:=pf24bit;
  WeltPos.x := max(min(WeltPos.x,LEVEL_SIZE),0);
  WeltPos.y := max(min(WeltPos.y,LEVEL_SIZE),0);
  for y:=0 to backbuffer.height-1 do begin
    Zeile:=backbuffer.ScanLine[y];

    for x:=0 to backbuffer.Width-1 do begin
      if (WeltPos.x+x<LEVEL_SIZE) and (WeltPos.y+y<LEVEL_SIZE) then

        //Hhe oder Tex anzeigen

      if Speedbutton4.Down then begin
        if (Welt[WeltPos.x+x][WeltPos.y+y].hoehe < 0) then begin
          Zeile[x*3]  :=255;
          Zeile[x*3+1]:=0;
          Zeile[x*3+2]:=0;
        end else begin
          Zeile[x*3]  :=0;
          Zeile[x*3+1]:=128+min(round(Welt[WeltPos.x+x][WeltPos.y+y].hoehe),127);
          Zeile[x*3+2]:=0;
        end;
      end else begin
        col1 := getTexColor(getFirstTexture(Welt[WeltPos.x+x][WeltPos.y+y].textur));
        col2 := getTexColor(getSecondTexture(Welt[WeltPos.x+x][WeltPos.y+y].textur));
        mult := getTexMulti(Welt[WeltPos.x+x][WeltPos.y+y].textur) / 15;
        tex1 := getFirstTexture(Welt[WeltPos.x+x][WeltPos.y+y].textur);
        tex2 := getSecondTexture(Welt[WeltPos.x+x][WeltPos.y+y].textur);
        hoehe := round(Welt[WeltPos.x+x][WeltPos.y+y].hoehe);
        if (Welt[WeltPos.x+x][WeltPos.y+y].hoehe < 0) then begin
          Zeile[x*3]  :=255;
          Zeile[x*3+1]:=0;
          Zeile[x*3+2]:=0;
        end else begin

        case tex1 of
          TEX_GRAS:begin
                red0 := max(min(255,hoehe),0);
		green0 := 128+max(min(127,hoehe),0);
		blue0 := max(min(255,hoehe),0);
          end;
          TEX_FELS:begin
          	red0 := 128+max(min(127,hoehe),0);
	  	green0 := 128+max(min(127,hoehe),0);
	        blue0 := 128+max(min(127,hoehe),0);
          end;
          TEX_ERDE:begin
          	red0 := 128+max(min(127,hoehe),0);
	        green0 := 64+max(min(127,hoehe),0);
		blue0 := 0;
          end;
          TEX_SCHNEE:begin
                red0 := 200+max(min(55,hoehe),0);
		green0 := 200+max(min(55,hoehe),0);
                blue0 := 255;//00+max(min(255,hoehe),0);
          end;
        end;

        case tex2 of
          TEX_GRAS:begin
                red1 := max(min(255,hoehe),0);
		green1 := 128+max(min(127,hoehe),0);
		blue1 := max(min(255,hoehe),0);
          end;
          TEX_FELS:begin
          	red1 := 128+max(min(127,hoehe),0);
	  	green1 := 128+max(min(127,hoehe),0);
	        blue1 := 128+max(min(127,hoehe),0);
          end;
          TEX_ERDE:begin
          	red1 := 128+max(min(127,hoehe),0);
	        green1 := 64+max(min(127,hoehe),0);
		blue1 := 0;
          end;
          TEX_SCHNEE:begin
                red1 := 200+max(min(55,hoehe),0);
		green1 := 200+max(min(55,hoehe),0);
                blue1 := 255;//00+max(min(255,hoehe),0);
          end;
        end;

        Zeile[x*3]    := round(blue0  * (1-mult) + blue1  * mult);
        Zeile[x*3+1]  := round(green0 * (1-mult) + green1 * mult);
        Zeile[x*3+2]  := round(red0   * (1-mult) + red1   * mult);
        end;
      end;

    end;
  end;

  stretchblt(Spielwelt.Canvas.Handle,0,0,Spielwelt.width,Spielwelt.Height,
    backbuffer.Canvas.Handle,0,0,backbuffer.Width,backbuffer.height,SRCCOPY);

  backbuffer.free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  zoom:=2;
  UpDown1.Position:=2;
  Button1Click(Sender);
  ComboBox1.ItemIndex:=0;
  ComboBox2.ItemIndex:=0;
  ComboBox3.ItemIndex:=0;
  VScrollbar.Max := LEVEL_SIZE;
  HScrollBar.Max := LEVEL_SIZE;
end;

procedure TForm1.UpDown1ChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  if (newValue>0) and (newValue<11) then begin
    label1.Caption:='Zoom: '+inttostr(newvalue);
    zoom:=newvalue;
    SpielweltPaint(Sender);
    VScrollbar.PageSize:=Spielwelt.Height div Zoom;
    HScrollbar.PageSize:=Spielwelt.Width div Zoom;
  end else AllowChange:=false;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  VScrollbar.PageSize:=Spielwelt.Height div Zoom;
  HScrollbar.PageSize:=Spielwelt.Width div Zoom;
end;

procedure TForm1.VScrollbarChange(Sender: TObject);
begin
  WeltPos.Y:=VScrollbar.Position;
  SpielweltPaint(Sender);
end;

procedure TForm1.HScrollbarChange(Sender: TObject);
begin
  WeltPos.X:=HScrollbar.Position;
  SpielweltPaint(Sender);
end;

procedure TForm1.SpielweltMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var wpos:TPoint;
begin
  wpos.x:=X div zoom + weltpos.X;
  wpos.y:=Y div zoom + weltpos.y;

  if Speedbutton1.down then begin
    if Button=mbLeft then begin
      Mountain(wpos,100-trackbar1.position,100-trackbar2.position);
      maustaste := maustaste or MB_LEFT;
    end;
    if Button=mbRight then begin
      Mountain(wpos,100-trackbar1.position,-(100-trackbar2.position));
      maustaste := maustaste or MB_RIGHT;
    end;
  end;
  if Speedbutton2.down then begin
    Texture(wpos);
    maustaste := maustaste or MB_LEFT;
  end;
  SpielweltPaint(Sender);
end;

procedure TForm1.SpielweltMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  maustaste := 0;
end;

procedure TForm1.SpielweltMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var wpos:TPoint;
    S:String;
    tex:byte;
begin
  wpos.x:=X div zoom + weltpos.X;
  wpos.y:=Y div zoom + weltpos.y;

  if (wpos.x<LEVEL_SIZE) and (wpos.y<LEVEL_SIZE) then begin
    if Speedbutton1.down then begin
      if maustaste=MB_LEFT then begin
        Mountain(wpos,100-trackbar1.position,100-trackbar2.position);
        SpielweltPaint(Sender);
      end;
      if maustaste=MB_RIGHT then begin
        Mountain(wpos,100-trackbar1.position,-(100-trackbar2.position));
        SpielweltPaint(Sender);
      end;
    end;

    if Speedbutton2.down then begin
      if maustaste>0 then begin
        Texture(wpos);
        SpielweltPaint(Sender);
      end;
    end;

    tex := Welt[wpos.x][wpos.y].textur;

    Statusbar1.SimpleText:='Textur: '+inttostr(round(100/16*getTexMulti(tex)))+getTexString(getFirstTexture(tex))+' / '+getTexString(getSecondTexture(tex));
  end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Panel3.visible:=false;
  Panel2.visible:=false;
  Panel1.visible:=true;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Panel1.visible:=false;
  Panel2.visible:=true;
  Panel3.visible:=false;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  Panel1.visible:=false;
  Panel2.visible:=false;
  Panel3.visible:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);
var F:file of TSpielfeld;
    item:TSpielfeld;
    i:integer;
begin
  if opendialog1.Execute then begin
    AssignFile(F,opendialog1.FileName);
    Reset(F);
    i:=0;
    while not eof(F) do begin
      Read(F,item);
      Welt[i mod LEVEL_SIZE][i div LEVEL_SIZE]:=item;
      inc(i);
    end;
    CloseFile(F);
  end;
  SpielweltPaint(Sender);
end;

procedure TForm1.Button3Click(Sender: TObject);
var F:file of TSpielfeld;
    i:integer;
begin
  if savedialog1.Execute then begin
    AssignFile(F,savedialog1.FileName);
    Rewrite(F);

    for i:=0 to LEVEL_SIZE*LEVEL_SIZE-1 do begin
      write(F,Welt[i mod LEVEL_SIZE][i div LEVEL_SIZE]);
    end;
    CloseFile(F);
  end;
end;

procedure BubbleSort(var A: array of single);
var
  I, J: Integer;
  T : single;
begin
  for I := Low(A) to High(A) - 1 do
    for J := High(A) downto I + 1 do
      if A[I] > A[J] then
      begin
        T := A[I];
        A[I] := A[J];
        A[J] := T;
      end;
end;

function getMaxInArray(A:array of integer):integer;
var i,max:integer;
begin
  max:=0;
  for i:=low(A) to high(A) do begin
    if A[i]>A[max] then max:=i;
  end;
  result:=max;
end;

procedure TForm1.Button4Click(Sender: TObject);
const radius=5;

var i,x,y,xm,ym,tex,max1,max2:integer;
    list:array[0..8]of single;
    cols:array[0..3]of integer;
begin
  randomize;
  case Combobox3.ItemIndex of
    0:begin
        for i:=0 to LEVEL_SIZE*LEVEL_SIZE-1 do begin
          Welt[i mod LEVEL_SIZE][i div LEVEL_SIZE].hoehe:=Welt[i mod LEVEL_SIZE][i div LEVEL_SIZE].hoehe * 0.9;
        end;
      end;
    1:begin
        for i:=0 to LEVEL_SIZE*LEVEL_SIZE-1 do begin
          Welt[i mod LEVEL_SIZE][i div LEVEL_SIZE].hoehe:=Welt[i mod LEVEL_SIZE][i div LEVEL_SIZE].hoehe * 1.1;
        end;
      end;
    2:begin
        for x:=0 to LEVEL_SIZE-1 do begin
          for y:=0 to LEVEL_SIZE-1 do begin
            xm := (x + LEVEL_SIZE);
            ym := (y + LEVEL_SIZE);
            list[0]:=Welt[(xm-1) mod LEVEL_SIZE][(ym-1) mod LEVEL_SIZE].hoehe;
            list[1]:=Welt[(xm-1) mod LEVEL_SIZE][(ym  ) mod LEVEL_SIZE].hoehe;
            list[2]:=Welt[(xm-1) mod LEVEL_SIZE][(ym+1) mod LEVEL_SIZE].hoehe;
            list[3]:=Welt[(xm  ) mod LEVEL_SIZE][(ym-1) mod LEVEL_SIZE].hoehe;
            list[4]:=Welt[(xm  ) mod LEVEL_SIZE][(ym  ) mod LEVEL_SIZE].hoehe;
            list[5]:=Welt[(xm  ) mod LEVEL_SIZE][(ym+1) mod LEVEL_SIZE].hoehe;
            list[6]:=Welt[(xm+1) mod LEVEL_SIZE][(ym-1) mod LEVEL_SIZE].hoehe;
            list[7]:=Welt[(xm+1) mod LEVEL_SIZE][(ym  ) mod LEVEL_SIZE].hoehe;
            list[8]:=Welt[(xm+1) mod LEVEL_SIZE][(ym+1) mod LEVEL_SIZE].hoehe;
            BubbleSort(list);
            Welt[x][y].hoehe := list[4];
          end;
        end;

      end;
    3:begin
        for x:=0 to 100000 do begin
          Mountain(Point(random(LEVEL_SIZE),random(LEVEL_SIZE)),random(25)+3,random(20)+1);
        end;
      end;
    4:begin
        for x:=0 to LEVEL_SIZE-1 do begin
          for y:=0 to LEVEL_SIZE-1 do begin
            cols[0]:=0;
            cols[1]:=0;
            cols[2]:=0;
            cols[3]:=0;
            //Einsetzen, welche Textur wie oft vorkommt
            for xm:=(x + LEVEL_SIZE - radius) to (x + LEVEL_SIZE + radius) do begin
              for ym:=(y + LEVEL_SIZE - radius) to (y + LEVEL_SIZE + radius) do begin
                tex := Welt[xm mod LEVEL_SIZE][ym mod LEVEL_SIZE].textur;
                inc(cols[getFirstTexture(tex)],15-getTexMulti(tex));
                inc(cols[getSecondTexture(tex)],getTexMulti(tex));
              end;
            end;
            xm := (x + LEVEL_SIZE);
            ym := (y + LEVEL_SIZE);

            //Die zwei hchsten rausfinden
            max1:=GetMaxInArray(cols);
            i:=cols[max1];
            cols[max1]:=0;
            max2:=GetMaxInArray(cols);
            cols[max1]:=i;

            Welt[xm mod LEVEL_SIZE][ym mod LEVEL_SIZE].textur := composeTexture(max1,max2,round(cols[max2]*15/(cols[max1]+cols[max2])));

          end;
        end;
      end;
  end;
  SpielweltPaint(Sender);
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
Spielweltpaint(Sender);
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
Spielweltpaint(Sender);
end;

end.
